// Mixture estimation
// - 3 binomial components, 1 variable 
//   (for more variables x use coding)
// - x=1,2,3,4
// - model: f(x|c=j), j=1,2,3
// ------------------------------------------
clc, clear, close, mode(0)
getd c:\functions

nd=100;
a=list();
a(1)=[.2]; 
a(2)=[.9];
a(3)=[.5];
N=5;
al=[.3 .5 .2];
for t=1:nd
  c(t)=(sum(cumsum(al)<randu(1,1)))+1;
  x(t,:)=grand(1,1,"bin",N,a(c(t)));
end
nc=length(a);

// Initialization
ni=10;                              // number of initial data
S=list(); th=list(); aI=list();
aI(1)=[.1];             // initial parameters
aI(2)=[.6];
aI(3)=[.4];
ka=ones(1,nc)*ni;
for j=1:nc
  S(j)=aI(j)*ka(j)*N;
  th(j)=S(j)/(ka(j)*N);
end

//  Estimation
t1=[]; t2=[]; t3=[];
for t=1:nd
  for j=1:nc
    th(j)=cut01(th(j));
    q(j)=binpdf(x(t),th(j),N);
  end
  w=fnorm(q);
  wt(:,t)=w;
  for j=1:nc
    S(j)=S(j)+w(j)*x(t);
    ka(j)=ka(j)+w(j);
    th(j)=S(j)/(ka(j)*N);
  end
  t1=[t1; th(1)]; t2=[t2; th(2)]; t3=[t3; th(3)]; //pause
end

[nill,cp]=max(wt,'r');
scf(); 
plot(t1(:,1),'-')
plot(t2(:,1),'g-')
plot(t3(:,1),'r-')
plot([nd/2 nd],[a(1) a(1)],':')
plot([nd/2 nd],[a(2) a(2)],'g:')
plot([nd/2 nd],[a(3) a(3)],'r:')
set(gca(),'data_bounds',[1 nd 0 1])

title 'Evolution of parameter estimates'

ACC=acc(c,cp)
