// T11simCont.sce
// SIMULATION OF THE SECOND ORDER REGRESSION MODEL
// Experiments
// - change parameters of the model
// - change the input signal
// - try to increase the model order to 3
// -------------------------------------------------------------------
exec('ScIntro.sce',-1), mode(0), getd('functions')

// PARAMETERS OF THE SIMULATION
nd=100;                       // length of data
a=[.4 .2];                    // parameters at y
b=[1 .2 -.5];                 // parameters at u
k=0;                          // constant (model absolute term)
s=.1;                         // noise variance

y(1)=1; y(2)=3;               // initial conditions for output
u=sin(10*%pi*(1:nd)'/nd)+.001*rand(nd,1,'n'); // input

// TIME LOOP OF THE SIMULATION
th=[a b k]';                  // vector of parameters
for t=3:nd
  // regression vector
  ps=[y(t-1) y(t-2) u(t) u(t-1) u(t-2) 1]';
  // regression model
  y(t)=th'*ps+s*rand(1,1,'n'); 
end

// RESULTS OF THE SIMULATION
set(gcf(),"position",[700 100 600 500])
subplot(211),plot(1:nd,u),title('Input')
subplot(212),plot(1:nd,y),title('Output')
