// Simulation of a mixture with regression components
// ------------------------------------------
clc, clear, close, mode(0)

nd=500;                                 // number of steps
th=[1 5 8];                             // component expectations
sd=[1 1 1]*.5;                          // component standard deviations
al=[.3 .4 .3];                          // switching probabilities
for t=1:nd
  c(t)=sum( cumsum(al)<rand(1,1,'u') )+1;
  x(t)=th(c(t))+sd(c(t))*rand(1,1,'n');
end
// results
scf();
subplot(211)
plot(x,ones(x),'x','markersize',10)
title('Generated values','fontsize',5)
subplot(212)
histplot(20,x);
title('Histogram of generated values','fontsize',5)
