// T47statEst_Noise.sce
// KALMAN AS A NOISE FILTER
// Experiments
// - change Rw and Rv to catch properly the signal
// - Rw ... changes of the signal
// - Rv ... changes of the noise
// -------------------------------------------------------------------
exec('ScIntro.sce',-1), mode(0), getd('functions')

// SIMULATION
tt=0:.1:(2*%pi);
nt=length(tt);
sd=2;                              // simulation noise
e=[sd*rand(1,nt,'n'); sd*rand(1,nt,'n')];
g=[10*cos(tt); 15*sin(tt)];        // pure signal (ellipse)
x=g+e;                             // measured noisy signal

// FILTRATION
Rz=1e6*eye(2,2);                   // state-estimate cov. matrix

Rw=1*eye(2,2);                   // state-model cov. matrix
Rv=10*eye(2,2);                    // output-model cov. matrix

M=[1 0                             // state-model matrices
   0 1];
A=[1 0
   0 1];
N=[0 0]';                          
F=[0 0]';
B=0;
G=0;
z(:,1)=[0 0]';                     // initial state

for t=2:nt
  [z(:,t),Rz,yp]=Kalman(z(:,t-1),x(:,t),0,M,N,F,A,B,G,Rw,Rv,Rz);
end

// Results
plot(g(1,:),g(2,:),'m:')
plot(x(1,:),x(2,:),'b.')
plot(z(1,:),z(2,:),'r.:')
