// T48statEst_NL.sce
// Nonlinear state model estimation
// ------------------------------------------
exec('ScIntro.sce',-1), mode(0), getd('functions')

nd=100;
// parameteers for simulation
u=1+1*rand(1,nd,'n');   // try 1, 10, -1, -2 (instead of 0)
xS=[0 0]';               // try xS=[10 -10]
// parameters for estimation
x=[0 0]';                               // initial state estimate
Rw=.1*eye(2,2);                         // covariance of state models
Rv=.01;                                 // covariance of output model
Rx=1000*eye(2,2);                       // covariance of the state estimate
for t=2:nd
  // simulation
  xS(1,t)=exp(-xS(1,t-1)-xS(2,t-1))+u(t)+.1*rand(1,1,'n');
  xS(2,t)=xS(1,t-1)-.3*u(t)+.1*rand(1,1,'n');
  y(t)=xS(2,t)+.01*rand(1,1,'n');
  // estimation
  M=[-exp(-x(1,t-1)-x(2,t-1)) -exp(-x(1,t-1)-x(2,t-1)); 1 0];
  F=[exp(-x(1,t-1)-x(2,t-1))+u(t); x(1,t-1)-3*u(t)]-M*x(:,t-1);
  A=[0 1];
  N=[0 0]'; B=0; G=0;
  [x(:,t),Rx,yp(t)]=Kalman(x(:,t-1),y(t),u(t),M,N,F,A,B,G,Rw,Rv,Rx);
  if abs(x(1,t))>100, x(1,t)=100+.1*rand(1,1,'u'); end
  if abs(x(2,t))>100, x(2,t)=100+.1*rand(1,1,'u'); end
end

scf();
subplot(211)
plot(1:nd,xS(1,:),1:nd,x(1,:))
set(gca(),'data_bounds',[1 nd -1 3])
subplot(212)
plot(1:nd,xS(2,:),1:nd,x(2,:))
set(gca(),'data_bounds',[1 nd -1 3])

Rpe1=variance(xS(1,:)-x(1,:))/variance(x(1,:))
Rpe2=variance(xS(2,:)-x(2,:))/variance(x(2,:))
