// T48statEst_Par.sce
// Nonlinear state model estimation
// ------------------------------------------
exec('ScIntro.sce',-1), mode(0), getd('functions')

nd=100;
// parameteers for simulation
aS=.3; bS=1;
u=1+1*rand(1,nd,'n');   // try 1, 10, -1, -2 (instead of 0)
xS=[0 0];                    // try xS=[10 -10]
// parameters for estimation
x=[0 0 0; 0 0 0]';                      // initial state estimate
Rw=.1*eye(3,3);                         // covariance of state models
Rv=.1;                                  // covariance of output model
Rx=1000*eye(3,3);                       // covariance of the state estimate
for t=3:nd
  // simulation
  xS(t)=exp(-aS*xS(t-1))+bS*u(t)+.1*rand(1,1,'n');
  y(t)=xS(t)+.1*rand(1,1,'n');
  // estimation
  M=[-x(2,t-1)*exp(-x(1,t-1)*x(2,t-1)) -x(1,t-1)*exp(-x(1,t-1)*x(2,t-1)) u(t);
     0 1 0
     0 0 1];
  F=[exp(-x(1,t-1)*x(2,t-1))+x(3,t-1)*u(t); x(2,t-1); x(3,t-1)]-M*x(:,t-1);
  A=[1 0 0];
  N=[0 0 0]'; B=0; G=0;
  [x(:,t),Rx,yp(t)]=Kalman(x(:,t-1),y(t),u(t),M,N,F,A,B,G,Rw,Rv,Rx);
//  if abs(x(1,t))>100, x(1,t)=100+.1*rand(1,1,'u'); end
//  if abs(x(2,t))>100, x(2,t)=100+.1*rand(1,1,'u'); end
end

scf();
subplot(311)
plot(1:nd,xS(1,:),1:nd,x(1,:))
set(gca(),'data_bounds',[1 nd -1 3])
title state
subplot(312)
plot(1:nd,x(2,:),[1 nd],[aS aS])
set(gca(),'data_bounds',[1 nd -1 3])
title aS
subplot(313)
plot(1:nd,x(3,:),[1 nd],[bS bS])
set(gca(),'data_bounds',[1 nd -1 3])
title bS

Rpe=variance(xS(1,:)-x(1,:))/variance(x(1,:))
