// T50ctrlMinVar.sce
// Minimum variance control
// Change: b0 to 0.2
// ------------------------------------------
exec('ScIntro.sce',-1), mode(0), getd('functions')

nd=200;
b0=1.2; a1=.9; b1=-.5; k=-3;            // model parametrs
y(1)=3; y(2)=-1; u=ones(1,2);
s=1*[ones(1,nd/2) -2*ones(1,nd/2)];     // setpoint
th=[a1 b1 k]'; /* parametres for control */
thE=rand(3,1,'n'); b0E=rand(1,1,'n');
V=1e-8*eye(5,5);
for t=3:nd
  ps=[y(t-1) u(t-1) 1]'; 
  select 2
  case 1, u(t)=1/b0*(s(t)-th'*ps);      // known parameters
  case 2, u(t)=1/b0E*(s(t)-thE'*ps);    // with estimation
  end
  
  y(t)=b0*u(t)+th'*ps+.1*rand(1,1,'u');
  // estimation
  Ps=[y(t) u(t) ps']';
  V=V+Ps*Ps';
  Vyp=V(2:5,1);
  Vp=V(2:5,2:5);
  P=inv(Vp)*Vyp;
  b0E=P(1);
  thE=P(2:4);
end

plot(1:nd,u,1:nd,y,1:nd,s,'--')
set(gca(),'data_bounds',[1 nd -3 6])
title 'Input, controlled output and setpoint'
legend('u','y','s');
