// T61classKn.sce
// Clasification with known components
// ------------------------------------------
exec('SCIHOME/ScIntro.sce',-1), mode(0), getd('functions')

nd=100;
// Simulation (three components)
th=[1 3 8];
sd=[1 1 1]*.5;
al=[.3 .4 .3];
for t=1:nd
  c(t)=(sum(rand(1,1,'u')>cumsum(al)))+1;    // pointer
  x(t)=th(c(t))+sd(c(t))*rand(1,1,'n');      // data
end

// Estimation iterations
nc=length(th);
for t=1:nd
  for j=1:nc
    [nill,qL(j)]=GaussN(x(t),th(j),sd(j)^2); // proximity
  end
  qL=qL-max(qL);
  q=exp(qL).*al';        // weights
  [nill,pt(t)]=max(q);   // estimate of the pointer
end

[c(1:10) pt(1:10)]       // 10 estimates

Accuracy=acc(c,pt)
