// T62classUnKn.sce
// Estimation with a teacher (known pointer values)
// ------------------------------------------
exec('ScIntro.sce',-1), mode(0), getd('functions')

nd=100;
nL=90;
// Simulation (three components)
thS=[1 3 8];
sdS=[1 1 1]*.5;
alS=[.3 .4 .3];
for t=1:nd
  c(t)=(sum(rand(1,1,'u')>cumsum(alS)))+1;   // pointer
  x(t)=thS(c(t))+sdS(c(t))*rand(1,1,'n');    // data
end
nc=length(thS);

// Estimation
for j=1:nc 
  k=find(c(1:nL)==j);    // times when c=j (1:nc)
  xx=x(k);               // data for j-th component
  th(j)=mean(xx);        // parameters for 
  vr(j)=variance(xx);    // .. j-th component
  al(j)=length(k)/nL;    // pointer model
end

// Testing
for t=nL+1:nd
  for j=1:nc
    [nill,qL(j)]=GaussN(x(t),th(j),vr(j));   // proximity
  end
  qL=qL-max(qL);
  q=exp(qL)*al(j);       // weights
  [nill,pt(t)]=max(q);   // point estimate
end

k=nL+1:nd;
Acc=acc(c(k),pt(k))
disp('Simulated and estimated pointer')
disp([c(k) pt(k)])
