// T63EM_C.sce
// EM-like algorithm (initial components)
// ------------------------------------------
exec('ScIntro.sce',-1), mode(0), getd('functions')

nd=100;
// Simulation (three components)
thS=[1 3 8];
sdS=[1 1 1]*.5;
alS=[.3 .4 .3];
for t=1:nd
  c(t)=(sum(rand(1,1,'u')>cumsum(alS)))+1;   // pointer
  x(t)=thS(c(t))+sdS(c(t))*rand(1,1,'n');    // data
end

// Estimation iterations
// - initial estimates
nc=length(thS);
th=[1 2 3];
vr=[1 1 1]*.1;
al=[1 1 1]/3;
tht=zeros(1,3);
for ite=1:100                 // iterations
  // - pointer estimation
  for t=1:nd
    for j=1:nc
      [nill,qL(j)]=GaussN(x(t),th(j),vr(j)); // proximity
    end
    qL=qL-max(qL);
    q=exp(qL);//.*al';        // weights
    [nill,pt(t)]=max(q);      // new pointer
  end
  // - parameter update
  for j=1:nc
    k=find(pt==j);            // estimation with a teacher
    xx=x(k);
    th(j)=mean(xx);           // new 
    vr(j)=variance(xx);       // .. parameters
    al(j)=length(k)/nd;       // pointer
  end
  tht(ite+1,:)=th;

  z=sum(abs(tht(ite+1,:)-tht(ite,:)));  // stopping rule
  if abs(z)<.01; ite, break, end
end

Accuracy=acc(c,pt)
set(scf(),'position',[800 200 400 300])
plot(tht)
title 'Evolution of component parameters'
