// T64Mix2Reg.sce
// Mixture estimation with static regression components
// - 3 components, 2 variables
// - static regression componets y=k+e
// ------------------------------------------
clc, clear, close, mode(0)
getd c:\functions

nd=300;
a=list();
a(1)=[5 -1];                  // 1st comp. sim.
a(2)=[1  6];                  // 2nd comp.
a(3)=[2 -1];                  // 3rd comp.
al=[.3 .5 .2];
for t=1:nd
  c(t)=(sum(randu(1,1)>cumsum(al)))+1;
  x(t,:)=a(c(t))+.1*randn(1,2);
end
nc=length(a);

// Initialization
V=list(); th=list(); aI=list();
aI(1)=[6 0];                  // 1st comp. ini.
aI(2)=[0 5];                  // 2nd comp.
aI(3)=[0 0];                  // 3rd comp.
ka=ones(1,nc);
ap=rand(3,3,'u');
for j=1:nc                    // initial statistics
  V(j)=[aI(j) 1]'*[aI(j) 1]+.00000001*ap(:,j)*ap(:,j)'; 
  th(j)=v2thN(V(j)/ka(j),2);
end

//  Estimation
t1=[]; t2=[]; t3=[];
for t=1:nd
  for j=1:nc
    [nill,qL(j)]=GaussN(x(t,:),th(j),.1);
  end
  qp=qL-max(qL); q=exp(qp);  //pause
  w=fnorm(q);
  wt(:,t)=w;
  for j=1:nc
    V(j)=V(j)+w(j)*[x(t,:) 1]'*[x(t,:) 1];
    ka(j)=ka(j)+w(j);
    th(j)=v2thN(V(j)/ka(j),2); 
  end
  t1=[t1; th(1)]; t2=[t2; th(2)]; t3=[t3; th(3)];
end

// Results
[nill,cp]=max(wt,'r');        // classification
ACC=acc(c,cp)

scf(); 
plot(t1(:,1),t1(:,2),'.:')
plot(t2(:,1),t2(:,2),'g.:')
plot(t3(:,1),t3(:,2),'r.:')
plot(aI(1)(1),aI(1)(2),'ko','markersize',8)
plot(a(1)(1),a(1)(2),'kx','markersize',14)
plot(a(1)(1),a(1)(2),'ko','markersize',14)
plot(aI(2)(1),aI(2)(2),'ko','markersize',8)
plot(a(2)(1),a(2)(2),'kx','markersize',14)
plot(a(2)(1),a(2)(2),'ko','markersize',14)
plot(aI(3)(1),aI(3)(2),'ko','markersize',8)
plot(a(3)(1),a(3)(2),'kx','markersize',14)
plot(a(3)(1),a(3)(2),'ko','markersize',14)
title 'Evolution of the parameter estimates  (big ox-true value)'
xlabel 'x1'
ylabel 'x2'


