// T64Mix3Ber.sce
// Mixture estimation (Bernoulli componets)
// - model  f(x|c=j), j=1,2,3
// - x  scalar
// ------------------------------------------
exec('ScIntro.sce',-1), mode(0), 
getd c:\functions

nd=500;
// Simulation
//thS=[.98 .01]; thS=[thS; 1-thS];
thS=[.7 .4]; thS=[thS; 1-thS];
alS=[.3 .7];
for t=1:nd
  c(t)=(sum(rand(1,1,'u')>cumsum(alS)))+1;
  x(t)=sum(cumsum(thS(:,c(t)))<rand(1,1,'u'))+1;
end

// Initialization
nc=length(alS);
th=[.6 .5]; th=[th; 1-th];
ka=ones(2,1)*10;
for j=1:nc
  S(:,j)=th(:,j)*ka(j);
end
S0=S;

// Estimation
for t=1:nd
  // classification
  for j=1:nc
    q(j)=th(x(t),j);
  end
  w=q/sum(q);
  select 2               // select type of w-transformtion
  case 1,
  case 2, w=wtr(w,5);  
  case 3, w=wdel(w);
  end
  wt(:,t)=w;
  // statistics update + parameter recomputation
  for j=1:nc
    S(x(t),j)=S(x(t),j)+w(j);
    th(:,j)=S(:,j)/sum(S(:,j)); // component parameters
  end
  [nill,pt(t)]=max(w);   // point estimate of the pointer value
  tht(t,:)=th(1,1:2)';
//pause
end

// Results
z=c2c(c,pt);             // rotation of cp
Acc=acc(c,z(pt))         // accuracy of classification
k=nd-10+1:nd;            // disp classification results
disp('10 last simulated and estimated pointer values')
disp([c(k) pt(k)])
set(scf(),'position',[800 100 500 400])
plot(tht)
title 'Evolution of component parameter estimates'
legend('par 1','par 2');
thS
thE=fix(th*100)/100
