// T65naiveB1_sim.sce
// Naive Bayes classification (known components)
// ------------------------------------------
exec('ScIntro.sce',-1), mode(0), getd('functions')

nd=100;
al=[.2 .1 .4 .3];                                      // switching probs.
//c 1 2  3  4
th=[1 5 10 14                                          // regression coefs.
    2 5 12 16
    0 4 11 18];
sd=[.2 .1 .15 .2];                                     // regression vars.
//simulation
for t=1:nd
  c(t)=(sum(rand(1,1,'u')>cumsum(al)))+1;              // pointer
  x(t,:)=th(:,c(t))+sd(c(t))*eye(3,3)*rand(3,1,'n');   // data
end

// classification
v=vals(c);
fc=fnorm(v(1,:));                                      // f(c)
for t=1:nd
  fx=zeros(1,4);
  for j=1:4
    for i=1:3
      fxi(i)=GaussN(x(t,i),th(:,j),sd(j));             // f(xi|cj)
    end
    fx(j)=prod(fxi);     // f(x|cj)=prod(f(xi|cj) ... NB method
  end
  fcx=fnorm(fc.*fx);                                   // f(c|x)
  [nill,cp(t)]=max(fcx);
end

Acc=acc(c,cp)

