// T65naiveB1_sim.sce XXX
// Naive Bayes classification (known components)
// ------------------------------------------
exec('ScIntro.sce',-1), mode(0), getd('functions')


dt=csvRead('hair.csv',';');
x=dt(2:$,1:2);
y=dt(2:$,3);
kx=max(x,'r');
ky=max(y);
nd=length(y);
printf('   Without NB - table  %d \n\n',prod(kx)*ky)

// estimation (with a teacher)
f(1).x=fnorm(table(x(:,1),y),1);        // table(kx,ky) .. 4x2
f(2).x=fnorm(table(x(:,2),y),1);        // table(kx,ky) .. 4x2
disp('Table x1,y: ',f(1).x)
disp('Table x2,y: ',f(2).x)

// classification (for known components)
fr=vals(y);       
fy=fnorm(fr(2,:));                      // fy
for t=1:nd
  fx=zeros(1,2);
  for j=1:2    // components
    for i=1:2  // variables     
      fxi(i)=f(i).x(x(t,i),j);          // f(xi|yj)
    end
    fx(j)=prod(fxi);                    // f(x|yj)=prod(f(xi|yj)
  end
  fyx=fnorm(fy.*fx);                    // f(y|x)
  [nill,yp(t)]=max(fyx);
end

printf('\n'),Acc=acc(y,yp)

