// T65naiveB2_iris.sce
// Naive Bayes classification in Iris database
// ------------------------------------------
exec('ScIntro.sce',-1), mode(0), getd('functions')

dt=csvRead('irisN.csv',';');

y=dt(:,$);
x=dt(:,1:4);

[nd,nx]=size(x);
ky=max(y);

// Learning with a teacher
for j=1:ky
  for i=1:nx
    xij=x(y==j,i);
    ch(j).x(i).m=mean(xij);   // characteristics of
    ch(j).x(i).v=cov(xij);    // normal components
  end
end
fy=fnorm(tableXY(y,ones(y),1:ky,1));    // fj(y)

// Classification
for t=1:nd
  xt=x(t,:);                            // measured x
  fx=fy;
  for j=1:ky
    for i=1:nx
      fx(j)=fx(j)*GaussN(xt(i),ch(j).x(i).m,ch(j).x(i).v); 
                                        // prod fj(xi|y) = proxim.
    end
  end
  fp=fnorm(fx);                         // normaliz. -> f(y|xt)

  [nill,yp(t)]=max(fp);
end

Acc=acc(y,yp)
