// T65naiveB3_hair.sce
// Data for KNIME - hair, eye, sex
// - cleaasification with discrete model
// - different data for learning and testing
// ------------------------------------------
exec('ScIntro.sce',-1), mode(0), getd('functions')

dt=csvRead('hair.csv',';');
// data  hair-eye-sex  with titles in the first row
nd=size(dt,1)-1;            // length of data
nL=round(.7*nd);

// Data for learning and testing
[dL,dT]=mixSamp(dt(2:$,:),nL);
x=dL(:,1:2);                       // hair, eye - explanatory
y=dL(:,$);                         // sex - target
nx=size(x,2);                      // number of variables
ky=max(y);                         // numb. of vals in y
for i=1:nx, kx(i)=max(x(:,i)); end // numb. of vals in x

// Learning
xj=list();
for i=1:nx
  fx(i).d=fnorm(tableXY(x(1:nL,i),y(1:nL),1:kx(i),1:ky),1);   
                                   // f(xi|yj) .. y is pointer
end
fy=fnorm(tableXY(ones(1,nL),y(1:nL),1,1:ky)); // f(y)

// Testing
clear x y
x=dT(:,1:2);                       // data for tesing
y=dT(:,3);
for t=1:(nd-nL)
  xt=x(t,:);                       // x to be classified
  ff=fy;
  for i=1:nx
    ff=ff.*fx(i).d(xt(i),:);       // f(y)*f(x1|y)*f(x2|y) .. NB
  end
  fp=fnorm(ff);                    // predictive pf
  [nill,yp(t)]=max(fp);            // point prediction
end

Acc=acc(y,yp)

